/****************************************************************
* Modul:   TA.BA_MMT.HS1301 - Multimedia Technik (MMT)
* Subject: Processing - Uebung 7 - Pixelbild
* Author:  Felix Rohrer
* Desc:    Pixelreduzieren
****************************************************************/

PImage original;
PImage bearbeitet;

int BORDER = 10;
int sumPixel = 1; // Anzahl Pixel zusammenfassen

// ----- setup() ------------------------------------------------
void setup() {
  //original = loadImage("lincoln.png");
  //original = loadImage("/wp-content/uploads/lincoln.png");
  original = loadImage("sonnenblume.jpg");
  
  updateImage();

  size(BORDER + original.width + BORDER + bearbeitet.width + BORDER, BORDER + original.height + BORDER);
}

// ----- draw() -------------------------------------------------
void draw() {
    background(255, 255, 255);
    image(original, BORDER, BORDER, original.width, original.height);
    image(bearbeitet, BORDER + original.width + BORDER, BORDER, bearbeitet.width, bearbeitet.height);
}


// ----- mouseMoved() -------------------------------------------
void mouseMoved() {
  sumPixel = (int) (255.0 / (displayWidth) * mouseX) + 1;
  updateImage();
}


// ----- updateImage() ------------------------------------------
void updateImage() {
  bearbeitet = new PImage(original.width, original.height);
  bearbeitet.loadPixels();

  for (int bearbeitetY = 0; bearbeitetY < original.height/sumPixel; bearbeitetY++) {
    for (int bearbeitetX = 0; bearbeitetX < original.width/sumPixel; bearbeitetX++) {
      int originalX = bearbeitetX * sumPixel;
      int originalY = bearbeitetY * sumPixel;
      int originalFarbe = getColor(original, sumPixel, originalX, originalY);

      setNewColor(bearbeitet, sumPixel, bearbeitetX * sumPixel, bearbeitetY * sumPixel, originalFarbe);
    }
  }
  bearbeitet.updatePixels();
}


// ----- getColor() ---------------------------------------------
int getColor(PImage image, int sumPixel, int xPos, int yPos) {
  color orgColor = 0;
  float r = 0;
  float g = 0;
  float b = 0;
  for (int y = 0; y < sumPixel; y++) {
    for (int x = 0; x < sumPixel; x++) {
      orgColor = image.pixels[(yPos + y) * image.width + (xPos + x)];
      r += orgColor >> 16 & 0xFF; // red(orgColor);
      g += orgColor >> 8 & 0xFF;  // green(orgColor);
      b += orgColor & 0xFF;       // blue(orgColor);
    }
  }
  return color(r / (sumPixel * sumPixel), g / (sumPixel * sumPixel), b / (sumPixel * sumPixel));
}


// ----- setNewColor() ------------------------------------------
void setNewColor(PImage image, int sumPixel, int xPos, int yPos, color newColor) {
  for (int y = 0; y < sumPixel; y++) {
    for (int x = 0; x < sumPixel; x++) {
      image.pixels[(yPos + y) * image.width + xPos + x] = newColor;
    }
  } 
}
